/*-
 * ~~~~~~licensing~~~~~~
 * object-runtime-core
 * ==========
 * Copyright (C) 2020 - 2025 EmDev LLC
 * ==========
 * You may not use this file except in accordance with the License Terms of the Copyright
 * Holder located at: https://entaxy.ru/eula . All copyrights, all intellectual property
 * rights to the Software and any copies are the property of the Copyright Holder. Unless
 * it is explicitly allowed the Copyright Holder, the User is prohibited from using the
 * Software for commercial purposes to provide services to third parties.
 * 
 * The Copyright Holder hereby declares that the Software is provided on an "AS IS".
 * Under no circumstances does the Copyright Holder guarantee or promise that the
 * Software provided by him will be suitable or not suitable for the specific purposes
 * of the User, that the Software will meet all commercial and personal subjective
 * expectations of the User, that the Software will work properly, without technical
 * errors, quickly and uninterruptedly.
 * 
 * Under no circumstances shall the Copyright Holder or its Affiliates is not liable
 * to the User for any direct or indirect losses of the User, his expenses or actual
 * damage, including, downtime; loss of bussines; lost profit; lost earnings; loss
 * or damage to data, property, etc.
 * ~~~~~~/licensing~~~~~~
 */
package ru.entaxy.platform.objects.runtime.impl.manager;

import java.util.HashMap;
import java.util.Map;

import ru.entaxy.platform.objects.runtime.EntaxyRuntimeObjectManager.ENTAXY_RUNTIME_OBJECT_OPERATION;
import ru.entaxy.platform.objects.runtime.EntaxyRuntimeObjectManager.ENTAXY_RUNTIME_OBJECT_OPERATION_RESULT;
import ru.entaxy.platform.objects.runtime.EntaxyRuntimeObjectManager.OperationResult;

public class OperationResultImpl implements OperationResult {

	public static OperationResultImpl createDone() {
		return (new OperationResultImpl()).result(ENTAXY_RUNTIME_OBJECT_OPERATION_RESULT.DONE);
	}

	public static OperationResultImpl createFailed() {
		return (new OperationResultImpl()).result(ENTAXY_RUNTIME_OBJECT_OPERATION_RESULT.FAILED);
	}

	public static OperationResultImpl createRequest() {
		return (new OperationResultImpl()).result(ENTAXY_RUNTIME_OBJECT_OPERATION_RESULT.REQUEST);
	}

	public static OperationResultImpl createBlocked() {
		return (new OperationResultImpl()).result(ENTAXY_RUNTIME_OBJECT_OPERATION_RESULT.BLOCKED);
	}

	public static OperationResultImpl createRequest(Map<String, ENTAXY_RUNTIME_OBJECT_OPERATION> affected) {
		OperationResultImpl result = createRequest();
		result.getAffected().putAll(affected);
		return result;
	}
	
	ENTAXY_RUNTIME_OBJECT_OPERATION_RESULT result;
	
	final Map<String, ENTAXY_RUNTIME_OBJECT_OPERATION> affected = new HashMap<>();
	
	String message = "";
	
	// OperationResult
	
	@Override
	public ENTAXY_RUNTIME_OBJECT_OPERATION_RESULT getResult() {
		return result;
	}

	@Override
	public Map<String, ENTAXY_RUNTIME_OBJECT_OPERATION> getAffected() {
		return affected;
	}

	@Override
	public String getMessage() {
		return message;
	}
	
	// others

	public OperationResultImpl result(ENTAXY_RUNTIME_OBJECT_OPERATION_RESULT result) {
		setResult(result);
		return this;
	}

	public void setResult(ENTAXY_RUNTIME_OBJECT_OPERATION_RESULT result) {
		this.result = result;
	}

	public OperationResultImpl message(String messageValue) {
		this.setMessage(messageValue);
		return this;
	};
	
	public void setMessage(String message) {
		this.message = message;
	}
	
	public OperationResultImpl affected(Map<String, ENTAXY_RUNTIME_OBJECT_OPERATION> affected) {
		this.affected.putAll(affected);
		return this;
	}
}
